<?php
/**
 * OntoWiki setup file
 * 
 * @author AKSW team
 */

/* deprecated since the debugging on/off switch is available 
error_reporting(E_ALL);
ini_set('display_errors', 'On');
*/
define('REAL_BASE', str_replace('app/config/', '', str_replace('\\', '/', dirname(__FILE__)) . '/'));
$GLOBALS['RAP']['conf']['database']['tblStatements'] = 'statements';
// ZENDED = Runs in ZENDED Mode (-> no session-start in Powl)
define('ZENDED', "YES");

/*
 * Set the include paths to include Zend framework
 * as well as own extensions.
 */
$include_path  = get_include_path() . PATH_SEPARATOR;
$include_path .= REAL_BASE . 'lib/' . PATH_SEPARATOR;
$include_path .= REAL_BASE . 'app/models/' . PATH_SEPARATOR;
$include_path .= REAL_BASE . 'lib/Erfurt/lib/' . PATH_SEPARATOR;
// $include_path.= get_include_path();
set_include_path($include_path);

/**
 * Load Zend loader
 */
require_once 'Zend/Loader.php';

/**
 * Define __autoload function to load undefined classes with
 * the Zend_Loader::loadClass method.
 */
function __autoload($class) {
	try {
		Zend_Loader::loadClass($class);
	} catch (Exception $e) {
		// echo get_class($e) . ': ' . $e->getMessage()."<br/>";
	}
}


/**
  * Create an instance of the Zend_Config class to read the configuration
  * settings from an ini file and register the configuration object in
  * the object store for later usage.
  */
$iniFiles = array(REAL_BASE . 'app/config/' . 'default.ini');
$section = 'default';
$privatIniFile = REAL_BASE . 'config.ini';
if (file_exists($privatIniFile)) {
	$iniFiles[] = $privatIniFile;
	$section = 'private';	
}
require_once 'Erfurt/Config.php';
$config = new Erfurt_Config($iniFiles, $section, true);

$config->iniFiles = $iniFiles;
$config->iniSection = $section;

// debug mode
if (isset($config->debugging) and (bool) $config->debugging) {
    // define global debugging constant
    define('_OWDEBUG', 1);
    // enable error reporting
    error_reporting(E_ALL);
    ini_set('display_errors', 'On');
}

// PHP version check
if (!version_compare(phpversion(), $config->version->min_php, '>=')) {
	throw new Erfurt_Exception('OntoWiki requires at least PHP Version ' . $config->version->min_php, 2001);
	exit();
}


/**
 * check for .htaccess
 */
if (!file_exists(REAL_BASE . '.htaccess'))
	die ("Setup Error: Please copy htaccess.dist to .htaccess and allow RewriteEngine for this directory.");


// register config object
Zend_Registry::set('config', $config);

/**
 * create config settings for multilanguage strings
 */
// TODO: check currently selected theme for overwritten strings.ini
$strFile = REAL_BASE . 'app/config/' . 'strings.ini';
$strings = new Zend_Config_Ini($strFile, (isset($config->language->gui)) ? $config->language->gui : 'default', true);
Zend_Registry::set('strings', $strings);

/**
 * Define a global function to get the rewrite base
 */
function getRewriteBase() {
	$url = Zend_Registry::get('config')->rewritebase;
	return $url;
}

/**
  * Include ERFURT
  */
// TODO: config wurde in erfurt.php modifiziert und gemerged.. norman hatte recht, ich lag falsch 
try {
	include_once REAL_BASE . Zend_Registry::get('config')->erfurtLib . 'erfurt.php';
	$erfurt = new Erfurt_App_Default(Zend_Registry::get('config'), '', '', true);
// catch erfurt-specific exceptions
} catch (Erfurt_Exception $ee) {
	if ($ee->getCode() < 2000) {
		renderInfo('Erfurt Info', $ee->getMessage());
	} else {
		renderError('Erfurt Error', $ee->getMessage());
	}
	exit();
// catch all other exceptions
} catch (Exception $e) {
	renderError('Error', $e->getMessage());
}

if (!is_object($erfurt)) {
    renderError('OntoWiki Error', 'OntoWiki configuration error: Could not initialize erfurt API.');
    exit;
}

//TODO: remove powl
$powl = $erfurt->getStore();

/**
 * load OntoWiki system ontology
 */
#$owSysOntModel = $erfurt->getStore()->getModel($config->sysont->model, array(), false);
#Zend_Registry::set('owSysOnt', $owSysOntModel);
Zend_Registry::set('owSysOnt', Zend_Registry::get('sysontModel'));
/**
 * Start the session
 */

#var_dump($_SESSION);exit; 
 
try {
    if (isset($config->session->timeout) && ((int)$config->session->timeout > 0)) {
        Zend_Session::rememberMe((int)$config->session->timeout);
    } 
    
    $session = new Zend_Session_Namespace(('OW' . Zend_Registry::get('sessionNsId')));
	Zend_Registry::set('session', $session);

} catch (Exception $e) {
	echo get_class($e) . ': ' . $e->getMessage();
	print '<br/>';
	print 'Look at erfurt include.php for session_start()!';
	exit;
}

// use default schema language if no language is set in session and if config parameter is set
if (!isset($session->modelLanguage) && isset($config->language->schema)) {
    $session->modelLanguage = $config->language->schema;
}

/**
 * set required path variables
 */
 // var_dump($_SERVER['SERVER_PROTOCOL']);exit;
$config->rewritebase = str_replace('boot.php', '', $_SERVER['PHP_SELF']);
$config->basepath = $config->rewritebase;
$config->uriBase = str_replace('boot.php', '', $_SERVER['PHP_SELF']);
$config->themeBase = $config->uriBase . $config->theme->path;
$config->erfurtUriBase = $config->uriBase . $config->erfurtLib;
$config->erfurtPublicUri =  $config->erfurtUriBase . 'public/';


/**
 * Create a route, an instance of the Zend_Controller_RewriteRouter, 
 * add the route and register router in the Zend Registry
 */
$actionRoute = new Zend_Controller_Router_Route(':controller/:action/:r', array('controller' => 'resource', 'action' => 'index'));
// the route for the resource controller omitting the controller name which defaults to 'resource'
// $resourceRoute = new Zend_Controller_Router_Route(':action/:r', array('controller' => 'resource', 'action' => 'view'));
// $route2 = new Zend_Controller_Router_Route('filenotfound/', array('controller' => 'index', 'action' => 'filenotfound'));
$router = new Zend_Controller_Router_Rewrite();

// $router->removeDefaultRoutes();
// $router->addRoute('resourceRoute', $resourceRoute);
$router->addRoute('actionRoute', $actionRoute);
// $router->setRewriteBase(getRewriteBase());
Zend_Registry::set('router', $router);

/**
 * Create an instance of OntoWiki_View, set the script path, add
 * the rewrite base as a template var and register it in the Zend
 * Registry
 */
$view = new OntoWiki_View(array(
	// 'basePath'   => REAL_BASE . $config->theme->path . 'templates/', 
	'scriptPath' => REAL_BASE . $config->theme->path . 'templates/', 
	'encoding'   => $config->encoding)
);

// set up view
$view->setEscape('htmlentities');
$view->setEncoding($config->encoding);

// set view helper path
$view->setHelperPath(REAL_BASE . 'lib/OntoWiki/Helper', 'OntoWiki_Helper');

// init layout
$layout = new Zend_Layout(array('viewSuffix' => 'php'), true);
$layout->setLayoutPath(REAL_BASE . $config->theme->path . 'templates/layouts');
// default layout file
// can be overridden in both controller and template
$layout->setLayout('main');

// set path to theme root as constant
define('THEMEROOT', REAL_BASE . $config->theme->path);

// set up view renderer
$viewRenderer = new Zend_Controller_Action_Helper_ViewRenderer($view, array('viewSuffix' => 'php'));
Zend_Controller_Action_HelperBroker::addHelper($viewRenderer);

/*
 * Create a widget factory and store a reference to it in the registry
 */
$wf = Erfurt_Plugin_Widget_Factory::getInstance();
Zend_Registry::set('widgetFactory', $wf);

/**
 * Create an instance of OntoWiki_Filter_Input for the global $_POST Array
 * and register it in the Zend Registry
 */
$post = $_POST; // new OntoWiki_Filter_Alnum($_POST, false);
Zend_Registry::set('post', $post);

/**
  * Set up event handler
  */
$eventDispatcher = Zend_Registry::get('erfurt')->getEventDispatcher();
Zend_Registry::set('ed', $eventDispatcher);

/**
 * Register a file log for all database amendments
 */
$logDir = REAL_BASE . 'log/';
if (is_writable($logDir) && ($config->logging != 'false')) {
	$levelFilter = new Zend_Log_Filter_Priority((int) $config->logging, '<=');
	
	$writer = new Zend_Log_Writer_Stream($logDir . 'controller.log');
	$logger = new Zend_Log($writer);
	$logger->addFilter($levelFilter);
} else {
	$writer = new Zend_Log_Writer_Null();
	$logger = new Zend_Log($writer);
}
Zend_Registry::set('owLog', $logger);
$logger->info('Start new Submit: ' . date('d.m.Y H:i:s'));

/**
  * Renders an HTML error page.
  *
  * @param string $errorHead Page title and H1 heading.
  * @param string $errorText The text to be dispalyed as error message.
  */
function renderError($errorHead, $errorText) {
	renderMsg($errorHead, $errorText, 'error');
}

/**
  * Renders an HTML info page.
  *
  * @param string $infoHead Page title and H1 heading.
  * @param string $infoText The text to be dispalyed as info message.
  */
function renderInfo($infoHead, $infoText) {
	renderMsg($infoHead, $infoText, 'info');
}

/**
  * Renders a generic HTML message page.
  *
  * @param string $head Page title and H1 heading.
  * @param string $text The text to be dispalyed as message.
  */
function renderMsg($head, $text, $type = 'info') {
global $config;
?>
<html>
<head>
<title><?php echo $head ?></title>
<style type="text/css">
<!--

body {
    font-family: sans-serif;
    line-height: 1.5;
    background: url(<?php echo $config->themeBase ?>images/layout-background-body.png) fixed no-repeat 97% 96% #eff9ff;
}

.info {
	margin: 0.5% 10%;
	border: 1px solid #aaa;
	padding: 1%;
	background-color: #f9f9f9;
}

.error {
	margin: 0.5% 10%;
	border: 1px solid #f00;
	padding: 1%;
	background-color: #fcc;
}
-->
</style>
</head>
<body>
<div class="<?php echo $type ?>">
<h1><?php echo $head ?></h1>
<p><?php echo $text ?></p>
</div>
</body>
</html>
<?php
}

?>
