<?php

/**
  * OntoWiki Error controller.
  * Fetched by default through the Zend_Controller_Plugin_ErrorHandler
  * 
  * @author Norman Heino <norman.heino@gmail.com>
  * @version $Id$
  */
class ErrorController extends Zend_Controller_Action {
	
	/**
	  * Default action that is triggered when an error occures
	  * during the dispatch process.
	  */
	public function errorAction() {
		$errors    = $this->_getParam('error_handler');
		$exception = $errors->exception;
		
		// check error type and send headers accordingly
		switch ($errors->type) {
			case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER:
			case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION:
				$this->getResponse()->setRawHeader('HTTP/1.1 404 Not Found');
				break;
			default:
				// don't change headers
		}
		
		// exception code determines whether error or info
		// see erfurt developer documentation
		if (($exception->getCode() > 0) && ($exception->getCode() < 2000)) {
			$this->view->head = 'OntoWiki Info';
			$this->view->type = 'info';
		} else {
			$this->view->head = 'OntoWiki Error';
			$this->view->type = 'error';
		}
		$this->view->text = get_class($exception) 
		                  . ': <strong>' 
		                  . $exception->getMessage() 
		                  . '</strong> -> ' 
		                  . $exception->getFile() 
		                  . '@' 
		                  . $exception->getLine();
		
		$this->view->base = Zend_Registry::get('config')->themeBase;
	}
}

?>
