<?php

/**
  * Checks if given Request-URI points to a file resource
  * available inside OntoWiki
  *
  * @author Christoph Rieß
  * @version $Id$
  * @package OntoWiki
  * @subpackage	Controller
  */
class OntoWiki_Controller_Plugin_ResourceToFile extends Zend_Controller_Plugin_Abstract {
	
	/**
	  * Overwrite postDispatch to get informed after any dispatching occurs.
	  * Method checks for downloadable content inside OntoWiki if dispatching-error occurs
	  */
	public function postDispatch(Zend_Controller_Request_Abstract $request) {
		
		if ($this -> _response -> isException() ) {
			// Construct full REQUEST URL with PROTOCOL extension
			if ($_SERVER['HTTPS'] == 'on') {
				$strURI = 'https://' . $_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
			} else {
				$strURI = 'http://' . $_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
			}
						
			$config = Zend_Registry::get('config');
			$fMime = $config -> filemanager -> file -> mimeproperty;
			$fClass = $config -> filemanager -> file -> ofclass;
			$fModel = $config -> filemanager -> file -> ofmodel;
			$fpath = REAL_BASE . $config -> filemanager -> path . md5($strURI);
			
			if (is_file($fpath) ) {
				
				$sysontModel = Zend_Registry::get('sysontModel');
				$query = 'SELECT DISTINCT ?P ?O WHERE { <' . $strURI . '> ?P ?O. } ORDER BY ?P';
				$result = $sysontModel -> sparqlQuery($query);
				foreach ($result as $r) {
					$key = $r['P']->getUri();
					$ar[$key] = $r['O']->getUri();
				}
				$erfurt = Zend_Registry::get('erfurt');
				if ($erfurt -> getAc() -> isModelAllowed( 'view',$ar[$fModel])) {
					header('Content-Type: ' . $ar[$fMime]);
					echo file_get_contents($fpath,'r');
				} else {
					header("HTTP/1.0 403 Forbidden");
					echo '<h3>Status 403 Forbidden</h3>';			
				}
				exit();
			} else {
				// Do nothing
			}
			
		} else {
			// Do nothing
		}
	}

}

?>
