<?php
/**
 * DL-Learner plugin class
 *
 * @author Maria Moritz & Vu Duc Minh
 * @version $Id$
 */
 
class Dllearner extends OntoWiki_Plugin {
  	
	protected static $_instance  = null;
	
	
	
	
  	protected function _initPlugin($erfurtobject) {
  		
		self::$_instance = $this;
	    parent::_initPlugin($erfurtobject);
	    return true;	    
  	}
    public static function getInstance() {
      if (null === self::$_instance) return false;
      return self::$_instance;
    }
   /**
     * grabs the dllearner action and the service controller name
     * given by the request object and
     * forwards it to the controller directory
     */  	
	public function grabLearner() {		
		
		$frontController = Zend_Controller_Front::getInstance();
		$request = $frontController->getRequest();
		$controllerName = strtolower($request->getControllerName());
		$actionName = strtolower($request->getActionName());
		
		if ($controllerName == 'service' && $actionName == 'dllearner') {

			$frontController->setControllerDirectory(dirname(__FILE__));
		}
	       
	}
	
	public function learndef() {		
	
		$frontController = Zend_Controller_Front::getInstance();
		$request = $frontController->getRequest();
		$controllerName = strtolower($request->getControllerName());
		$actionName = strtolower($request->getActionName());
		
		
	       if ($controllerName == 'resource' && $actionName == "learndef"){
		  
			$frontController->addControllerDirectory(dirname(__FILE__));

    

		}
	}
	
	public function learninc() {		
		
		$frontController = Zend_Controller_Front::getInstance();
		$request = $frontController->getRequest();
		$controllerName = strtolower($request->getControllerName());
		$actionName = strtolower($request->getActionName());
		
		
	       if ($controllerName == 'resource' && $actionName == "learninc"){
		  
			$frontController->addControllerDirectory(dirname(__FILE__));

    

		}
	}
   /**
     * if a model ist active and the DL-Learner action and
     * model action is allowed and identity isn't anonymous
     * the DL-Learner entry will be displayed in the extras menu
     */
	public function expandExtrasMenu (&$extrasMenu) {
		
		$this->model = Zend_Registry::get('config')->activeModel;
		$this->_ac = Zend_Registry::get('ac');
		$auth      = Zend_Auth::getInstance();
        $identity  = $auth->getIdentity();

        if($this->model){
        	$isModel = $this->_ac->isModelAllowed('edit', $this->model->getModelURI());
        	$isAction = $this->_ac->isActionAllowed('Dllearner');
        	
        	//if($identity['anonymous'] != true && $this->_ac->isModelAllowed('list', $this->model->getModelURI()) && $this->_ac->isActionAllowed('Dllearner')) {
			if(!$identity['anonymous'] && $isAction && $isModel) {        
        		array_push( $extrasMenu, '<a class="dllOpen" name="start" >DL-Learner</a>');
				return true;	
        	}
        }
	}
	
    /**
     * adds Dllearner.js for javascript usage
     *
     */
	public function addIncludes(&$includes){

		$includes.='<!-- Dllearner scripts -->'. PHP_EOL;
		$includes.='<script type="text/javascript" src="'.$this->_getPluginBaseUri().'/Dllearner.js"></script>'.PHP_EOL;
		$includes.='<!-- End of Dllearner scripts -->'.PHP_EOL;
		return true;
	}
}
?>