<?php

class Example extends OntoWiki_Plugin {

    public function addExampleInfo(&$str) {

        // for event 'exampletrigger', triggered in OntoWiki_Controller_Action::getOntoWikiBox2()

        $str .= '<p class="clearfloat messagebox success">Example plugin says: PluginManager and EventDispatcher work.</p>' . PHP_EOL;
        return true;
    }

    public function addContentToBox(&$box) {

        // for event 'create_sidecontent_OntoWikiBox', triggered in OntoWiki_Controller_Action::getOntoWikiBox2()

        // add content
        if (isset($box['content']))
            $box['content'] .= '<p class="messagebox info">Nice!</p>' . PHP_EOL;

        // add something to the dropdown menu            
        if (isset($box['menu']) && is_array($box['menu']) && 0 < $i = count($box['menu'])) {
            # insert new item before last menu item
            $i--;
            if (false !== $pos = strpos($box['menu'][$i],'<li class="last-child">')) {
                $box['menu'][$i] = substr($box['menu'][$i],0,$pos).
                                   '<li><a href="http://ontowiki.net/Projects/OntoWiki/EventPluginArchitecture">Plugin Manual</a></li>'.
                                   substr($box['menu'][$i],$pos);
            }
                
        }
        
        return true;
    }
    
    public function changeTitleAtPostDispatch($triggerplugin)
    {
        // for event 'ZendPostDispatch', triggered automatically
        
        // add something to title
        if (isset($this->_view) && $this->_view) {
            $this->_view->headTitle(' (and Exampleplugin)');
        }
    }

    public function addWindowToView(&$newWindow)
    {
        // for event 'template_plugin_example_data', triggered in view (_includes/footer.php)

        $newWindow = array('cssId'=>'pluginExampleWindow','title'=>'Example Plugin','content'=>'<p class="messagebox info">Example plugin thinks: let\'s add a window.</p>');
        return true;
    }

    public function addInfoUnderMainwindow(&$infoline)
    {
        // for event 'template_plugin_example_directoutput', triggered in view (_includes/footer.php)

        echo '<p class="messagebox">';
        echo "This is OntoWiki with a running Exampleplugin<br/>\n";
        echo 'Exampleplugin root dir: '.$this->_getPluginRootDir()."<br/>\n";
        echo 'Exampleplugin web base: '.$this->_getPluginBaseUri();
        echo '</p>';
        return true;
    }
    
    public function changeTabs(&$tabsArray)
    {
        // for event 'template_window_create_tabs', triggered in OntoWiki_Controller_Action::getTabs()

        // add a new tab
        $tabsArray['tabs'][$this->_getOntoWikiBaseUri().'/examplecontroller/exampleaction'] = 'Example Tab';
        
    }

	/**
	  * Used as event handler for 'default_resource_view_ZendPostDispatch' event
	  * and direct from the Example controller (to replace template folder).
	  * The 'default_resource_view_ZendPostDispatch' event is triggered automatically
	  * for the 'ZendPostDispatch' event while calling the 'view' action of the
	  * 'resource' controller of the 'default' module (OntoWiki only has the
	  * 'default' module so far).
      */
	function changeViewTemplate($onlyFolder)
	{
        
        // for event 'default_resource_view_ZendPostDispatch', triggered automatically
        
        // Often we know that the we have a registered view and the viewRenderer helper
        // but in generally we cannot assume that for every controller/action, so we have
        // to set up the $_view and $_viewRenderer objects for the actually used environment first.
        
        $this->_setEnvironment();
        
        // 1. Test for _viewRenderer helper and _view object
        
        if ($this->_viewRenderer != null && $this->_view != null) {
        
		    // 2. add the template folder within the plugin folder (use _view object)
		    // using Erfurt_Plugin:_getPluginRootDir to create the absolute folder name of the plugin directory
		    $this->_view->addScriptPath($this->_getPluginRootDir().'/templates/');
        
		    // 3. exchange the template script (use _viewRenderer helper)
		    // within your template folder, the script must be in a folder called like
		    // the controller (lowercase!, it is 'resource' in our example)
		    // - We only check for $onlyFolder here b/c we use this method from the Example controller, too.
		    if ($onlyFolder !== true)
		        $this->_viewRenderer->setScriptAction('replace-view'); // set name (NAME.php) of template, NAME is 'replace-view'
		        // alltogether the template for /resource/view is now PLUGINFOLDER/templates/resource/replace-view.php
        }
        
        return true;
        
	}

	/**
	  * Used as event handler for 'ZendRouteShutdown' event which is triggered
	  * automatically. It uses Zend_Controller_Front to add a new controller
	  * directory where the Example controller is located.
      */
    function changeController()
    {
	    // 1. get front controller
        $frontController = Zend_Controller_Front::getInstance();

        // 2. get request object
        $request = $frontController->getRequest();

        // 3. save controller and action names
        $controller = $request->getControllerName();
        $action     = $request->getActionName();
        
        // 4a. check for controller/action name (your new controller)
        if ($controller == 'examplecontroller') {
            // add the plug-in dir as a controller dir
            $frontController->addControllerDirectory($this->_getPluginRootDir().'/controller/');
        }

    }

}


?>
