<?php

/**
 * Main Class of our plugin doing only setting correct controller 
 * dir in case of firefoxextension controller is called.
 */
class FirefoxExtension extends OntoWiki_Plugin {
	
	/**
	 * Method for redirecting special requests exclusively to our own
	 * controller which does all the plugins actions.
	 * 
	 * @return void/nothing
	 */
	public function grabActions() {

		// get front controller
		$frontController = Zend_Controller_Front::getInstance();

		// get request object
		$request = $frontController->getRequest();

		// save controller and action names
		$controller = $request->getControllerName();
		$action     = $request->getActionName();
		
		// Use our controller if SoftWiki Plugin is active and
		// firefoxextension-controller is called
		if ($this->_pluginManager->getPluginRoot('SoftWiki') && $controller == 'firefoxextension') {
			// Set directory for our controller (Zend Framework only supports
			// one controller directory although the methods name contains add)
			$frontController->addControllerDirectory(dirname(__FILE__) . '/controllers');
		}
		
	}
	
}

?>