<?php

/**
 * Example Controller to show howto use templating and layouting
 * (or better not to use layouting but only templating for your special service)
 *
 */
class FirefoxextensionController extends OntoWiki_Controller_Action {

	/**
	 * init Method called every time class is instanciated
	 * does very simple things for us here that are:
	 * - disabling layouting
	 * - setting view variable for BaseUri of Plugin
	 * 
	 * @return void/nothing
	 */
	function init() {
		// init from superclass
		parent::init();

		// disable ontowiki layouting
		$this->_helper->layout->disableLayout();
		
		// save basedir of this plugin to the view
		$baseuri = str_replace ('boot.php','',$_SERVER['PHP_SELF']) . 'plugins/FirefoxExt/';
		$this -> view -> pluginBaseUri = $baseuri;

	}
	

	/**
	 * An example action called 'view'
	 * all methods related to actions must be named
	 * after the xyAction scheme where the ontowiki path is
	 * /controllername/xy
	 * 
	 * the method contains example on accessing 
	 * authentication data and parameters.
	 * 
	 * @return void/nothing
	 */
	function viewAction() {
		
		// Get current identity
		// $identity is array with keys: 'username', 'uri', 'dbuser', 'email', 'anonymous'
		// it comes from current OntoWiki session done by authentication adapter
		
		$identity = Zend_Auth::getInstance()->getIdentity();
		var_dump($identity);exit();
		if ($identity['anonymous']) {
			$this -> view -> identity = false;
		} else {
			$this -> view -> identity = $identity; 
		}
		
		// Accessing parameters and setting view vars.
		// parameters could be GET/POST/Zend-Style-GET
		// Zend-Style-GET is:
		// /name1/value1/name2/value2/name3/value3 appended like
		// 'normal' GET vars
		$params = $this->_request->getParams();
		$data = array();
		
		if ($params['uri']) {
			$data['uri'] = $params['uri'];
		} else {
			$this -> view -> error = array('Parameter missing: "uri" - Resource URI');
		}
		
		$this -> view -> data = $data;
	}
	

	/**
	 * Another action that could be useful for our needs ...
	 * if not, delete it
	 *
	 */
	function editAction() {

		$title= $_POST['reqtitle'];
		$text = $_POST['reqtext'];
		$reqelem = $_POST['reqelem'];
		$tags = $_POST['tags'];

		// get url
		$url = $_SESSION['url'];
		$urltitle = $_SESSION['urltitle'];

		// content area size
		$width = $_SESSION['width'];
		$height = $_SESSION['height'];

		// get user
		$username = $_SESSION['username'];
		$role = $_SESSION['role'];

		// get user agent
		$user_agent = $_SERVER['HTTP_USER_AGENT'];

		// get geocoordinates
		$lat = $_SESSION['lat'];
		$lon = $_SESSION['lon'];

		// get ip
		$ip = $_SESSION['ip'];

		// save to db only if text was written
		if (trim($text) != '') {
			$this -> view -> content =
			'<input type="hidden" id="selectionActive" name="selectionActive" value="false" />' . PHP_EOL .
			'<br/><h3 align="center">Vielen Dank f&uuml;r Ihre Eingabe.</h3>' . PHP_EOL .
			'<p align="center"><a href="" onclick="self.close()">Fenster schlie&szlig;en.</a></p>' . PHP_EOL;

			// unset saved form input
			unset($_SESSION['form_title']);
			unset($_SESSION['form_text']);
			unset($_SESSION['form_tags']);

			if ($tags != '') {
				// tag postprocessing
				$tags = trim($tags);
					
				$tags = utf8_encode(strtolower(utf8_decode($tags)));
					
				$tags = str_replace(",", " ", $tags);
					
				// delete double tags
				$tags_array = explode(" ", $tags);
				$tags_array = array_unique($tags_array);
				$tags = implode(" ", $tags_array);
					
			}

			// change texts in stemmed version
			$stemmed_title = utf8_encode(strtolower(utf8_decode($title)));
			$stemmed_title = $this->taglist($stemmed_title);
			$stemmed_text = utf8_encode(strtolower(utf8_decode($text)));
			$stemmed_text = $this->taglist($stemmed_text);

			// add information
			require_once('../db_connect_softwiki.php');
			$eintrag = "INSERT INTO requirements (title, stemmed_title, text, stemmed_text, man_tags, pathToElement, ip, url, user_agent, view_width, view_height, latitude, longitude, username, role)
			VALUES ('$title', '$stemmed_title', '$text', '$stemmed_text', '$tags', '$reqelem', '$ip', '$url', '$user_agent', '$width', '$height', '$lat', '$lon', '$username', '$role')";
			$eintragen = mysql_query($eintrag);

		} else {
			$this -> view -> content =
			'<input type="hidden" id="selectionActive" name="selectionActive" value="true" />' . PHP_EOL .
			'<br/><h3 align="center">Bitte geben Sie eine Textbeschreibung an.</h3>' . PHP_EOL .
			'<p align="center"><a href="index.php">Zur&uuml;ck</a> | <a href="#" onclick="self.close()">Fenster schlie&szlig;en.</a></p>' . PHP_EOL ;
		}
		
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $text
	 * @return unknown
	 */
	function taglist($text) {
		
		include('../lib/class.porterStemmer.php');
		
		$taglist = '';

		$stemmer = new PorterStemmer_de;

		// write words in array
		$tags = str_word_count($text, 1);

		for ($i = 0; $i < count($tags); $i ++) {
		 	$stem = $stemmer->stem($tags[$i]);
		 	$taglist .= $stem . ' ';
		}
		
		return $taglist;
	}
} 
?>
