<?php

/**
 * OntoWiki resource controller class which handles all resource-associated requests.
 *
 * @author OWMapPlugin-Team <mashup@comiles.eu>
 * @version 0.0.3
 * @package Kartenproto
 */

require_once "app/controllers/ResourceController.php";
class MappluginresourceController extends ResourceController {

    public function init() {
        /**
         * call the init() function of the parrent class
         */
        parent::init();
        /**
         * call the changeViewTemplate() function of the MapPlugin, to set the view template
         * you can find this function in the MapPlugin.php in the plugin root
         */
        $this->erfurtApp->getPluginManager()->prepare('MapPlugin')->changeViewTemplate(true);

        /**
         * indexAction function will be called if the controller is called without an action
         */ }
        public function indexAction() {

            /**
             * change view script to exampleaction-view
             */
            Zend_Controller_Action_HelperBroker::getStaticHelper('viewRenderer')->setScriptAction('map');

            /**
             * run the mapAction
             */
            return $this->mapAction();
        }

        /**
         *  Renders an instance's Google map page.
         */
        public function mapAction() {
            $actionConfig = $this->erfurtApp->getAc()->getActionConfig('MapPlugin');
            // this returns the google-apikey if found in the 
            // "OntoWiki System Configuration" -> "Action" -> "mapPlugin"
            $actionConfig['google'];
            /*
            other things that can be found there:
                map24=""
                maporder=osm-mapnik,metacarta
                google=""
                MaxMarkers=2
                GridCount=3
                yahoo=""
                enable=true */

            // get plugins root-directory to specify the rdf-filepath
            $pluginRootDir = $this->erfurtApp->getPluginManager()->prepare('MapPlugin')->getPluginRootDir();
            // get some strings from registry :-)
            // I think it is for language service
            $this->_strings = Zend_Registry::get('strings');
            // if the MapPlugin model doesn't exist
            // it will be imported
            if(!$this->erfurtStore->modelExists('http://ns.aksw.org/MapPlugin/')){
                // import the default ontology ($modelURI, $file, loadImport, $stream, $filetype)
                $check = $this->erfurtStore->loadModel('http://ns.aksw.org/MapPlugin/', $pluginRootDir . '/files/mapplugin.rdf', false, false, 'rdf');		
            }
            // try to add some action data into OntoWiki config model (admin requiered)

            try {$actionConfig = $this->erfurtApp->getAc()->getActionConfig('MapPlugin');
		// checks if MapPlugin-action not exists and imports it
		if(empty($actionConfig)) {
		        $m = $this->erfurtStore->getModel('http://localhost/OntoWiki/Config/');
		        $tempModel = new MemModel();
		        $tempModel->load($pluginRootDir . '/files/actionconfig.rdf', 'rdf', false);
		        $m->addModel($tempModel);
		}
            } 
            catch (Exception $e) {
                // no errorhandling at the moment
            }
            // get plugins root-directory to specify the rdf-filepath
            $pluginRootDir = $this->erfurtApp->getPluginManager()->prepare('MapPlugin')->getPluginRootDir();

            // Get the localization from the strings.ini file
            $this->_strings = Zend_Registry::get('strings');

            // if the MapPlugin model doesn't exist
            // it will be imported
            if(!$this->erfurtStore->modelExists('http://ns.aksw.org/MapPlugin/')){
                // import the default ontology ($modelURI, $file, loadImport, $stream, $filetype)
                $check = $this->erfurtStore->loadModel('http://ns.aksw.org/MapPlugin/', $pluginRootDir . '/files/mapplugin.rdf', false, false, 'rdf');		
            }
            // try to add some action data into OntoWiki config model (admin requiered)
            // !!!hope it won't die if a user opens a map!!!
            try {$actionConfig = $this->erfurtApp->getAc()->getActionConfig('MapPlugin');
		// checks if MapPlugin-action not exists and imports it
		if(empty($actionConfig)) {
		        $m = $this->erfurtStore->getModel('http://localhost/OntoWiki/Config/');
		        $tempModel = new MemModel();
		        $tempModel->load($pluginRootDir . '/files/actionconfig.rdf', 'rdf', false);
		        $m->addModel($tempModel);
		}
            } 
            catch (Exception $e) {
                // no errorhandling at the moment
            }
/*
        $m = $this->erfurtStore->getModel('http://localhost/OntoWiki/Config/');
        $tempModel = new MemModel();
        $tempModel->load($pluginRootDir . '/files/config.rdf', 'rdf', false);
        $m->addModel($tempModel);
**/
            // Disable layout
            //      $this->_helper->layout->disableLayout();
            // Disable rendering :-)
            //      $this->_helper->viewRenderer->setNoRender(true);
            // to get a working model
            $this->model = Zend_Registry::get('config')->activeModel;
            $this->session = Zend_Registry::get('session');


            $viewSub = '<span class="window-view-menu">'.$this->strings->mapplugin->main->viewmenu.'</span>';


            $menu   = array( $viewSub );

            /**
             * The getTabNavigation function is caled from ResourceController-Class, to get the Tabs, the parameter 1 stands for the 2nd tab, the map-tab
             */
            $tabs   = $this->getTabNavigation(1);

            $this->view->menu  = $menu;
            $this->view->tabs  = $tabs;
            $this->view->title = "OntoWiki MapPlugin";


            /**
             * Get the Google API Key from Configuration or from URL
             */
            foreach ($this->config->map->keys->toArray() as $key) {
                if ($key['url'] === $this->_request->getServer('HTTP_HOST')) {
                    $keyToUse = $key['key'];
                    break;
                }
            }
            if (!$keyToUse) {
                $keyToUse = $this->config->defaultMapKey;
            }

            $this->view->apiKey			= $keyToUse;
            $this->view->pluginBaseUri	= $this->erfurtApp->getPluginManager()->prepare('MapPlugin')->getPluginBaseUri();
            // get the currently selected class
            $this->view->uri			= $this->_request->getParam('r',null);
            if ( isset($_GET['select']) ) {
                $this->view->uri			.= "?" . $this->urlencode_array(array($_GET['select']), 'select' );
            }
            if(isset($_GET["zoom"]))	$this->view->zoom	= $_GET["zoom"];
            if(isset($_GET["lat"]))		$this->view->lat	= $_GET["lat"];
            if(isset($_GET["lon"]))		$this->view->lon	= $_GET["lon"];
            if(isset($_GET["layers"]))	$this->view->layers	= $_GET["layers"];
        }

        private function urlencode_array(
            $var,                // the array value
            $varName,            // variable name to be used in the query string
            $separator = '&'    // what separating character to use in the query string
        ) {
            $toImplode = array();
            foreach ($var as $key => $value) {
                if (is_array($value)) {
                    $toImplode[] = $this->urlencode_array($value, "{$varName}[{$key}]", $separator);
                } else {
                    $toImplode[] = "{$varName}[{$key}]=".urlencode($value);
                }
            }
            return implode($separator, $toImplode);
        }

}

?>
