<?php

/**
  * OntoWiki Window Template
  *
  * @author Norman Heino
  * @version $Id: window.php 2363 2008-06-04 08:57:43Z fusel2k $
  */

?>
<?php
if (isset($this->cssId)) {
	$idString = ' id="' . $this->cssId . '"';
}
?>
<?php if (isset($this->content) && !empty($this->content)): ?>
<div<?php echo $idString ?> class="window <?php echo $this->cssClasses ?>">
<?php 
if (isset($this->headingLevel)) {
	$hl = $this->headingLevel;
} else {
	$hl = '1';
}

if ($this->innerWindows && !empty($this->innerWindows)) {
	$innerWindows = true;
} else {
	$innerWindows = false;
}
?>
<h<?php echo $hl ?> class="title"><?php echo $this->title ?></h<?php echo $hl ?>>
<?php if (isset($this->tabs) && $this->tabs != ''): ?>
	<ul class="tabs">
	<?php echo $this->tabs ?>
	</ul>
<?php endif; ?>

<?php if (isset($this->content)): ?>
<?php if ($innerWindows): ?>
	<div class="content has-innerwindows">
<?php else: ?>
	<div class="content">
<?php endif; ?>

<?php if (isset($this->statusTools) || isset($this->statusLines)): ?>
<div class="messagebox info">
<?php
	if (isset($this->statusLines)) {
		foreach ($this->statusLines as $sL) {
			echo '<p class="statusline">' . $sL . '</p>';
		}
	}
	if (isset($this->statusTools)) {
		foreach ($this->statusTools as $sT) {
			echo '<div class="statustool">' . $sT . '</div>';
		}
	}
?>
</div>
<?php endif; ?>

<?php if ($innerWindows): ?>
	<div class="innercontent">
<?php endif; ?>

<?php if (!empty($this->errors)): ?>
	<div class="messagebox error">
		<?php foreach ($this->errors as $error): ?>
			<p><?php echo $error ?></p>
		<?php endforeach; ?>
	</div>
<?php endif?>

<?php if (!empty($this->messages)): ?>
	<div class="messagebox success">
		<?php foreach ($this->messages as $msg): ?>
			<p><?php echo $msg ?></p>
		<?php endforeach; ?>
	</div>
<?php endif?>

<?php echo $this->content ?>

<?php if ($innerWindows): ?>
	</div class="innercontent"><!-- innercontent -->
<?php endif; ?>

<?php if ($innerWindows): ?>
	<div class="innerwindows">
		<?php // foreach ($this->innerWindows as $innerWindow): ?>
		    <?php
		    echo $this->processEvent('innerwindows_start');
			echo $this->innerWindows;
		    ?>
		<?php // endforeach; ?>
	</div><!-- innerwindows -->
<?php endif; ?>

</div> <!-- window content -->
<?php endif; ?>

<?php if (is_array($this->menu) && !empty($this->menu)): ?>
	<ul class="menu">
		<?php foreach ($this->menu as $m): ?>
			<?php if ($m): ?>
				<li><?php echo $m ?></li>
			<?php endif; ?>
		<?php endforeach; ?>
	</ul>
<?php endif; ?>

<?php if (is_array($this->contextMenu) && !empty($this->contextMenu)): ?>
	<div class="contextmenu">
		<?php foreach ($this->contextMenu as $cM): ?>
			<?php echo $cM ?>
		<?php endforeach; ?>
	</div>
<?php endif; ?>

</div> <!-- window -->
<?php endif; ?>
