<?php

/**
 * OntoWiki query template
 *
 * @author Norman Heino, Sebastian Dietzold
 * @version $Id: query.php 2363 2008-06-04 08:57:43Z fusel2k $
 */

?>

<?php $this->placeholder('title')->set($this->title) ?>
<?php $this->placeholder('errors')->set($this->errors) ?>
<?php $this->placeholder('messages')->set($this->messages) ?>
<?php $this->placeholder('menu')->set($this->menu) ?>
<?php

if ($this->model instanceof RDFSModel) {
	$baseUri = $this->model->getBaseUri(); // base uri
	$nss = $this->model->getParsedNamespaces(); // namespaces
}

?>
<div class="content has-innerwindows">
<form method="post"
	action="<?php echo $this->owUriBase ?>resource/query/"
	class="crow-input cinput-justify-left">
<div class="innercontent">
<fieldset>
<div><!-- <label class="display-block" for="sparqlArea">SPARQL Query</label> -->
<textarea class="width99 code-input" id="sparqlArea" name="query"><?php echo urldecode(stripslashes($this->q)) ?></textarea>
<br class="clearall">
</div>
<div>
<button type="submit">Submit Query</button>
</div>
</fieldset>
</div>

<div class="innerwindows"><?php if ($nss): ?>
<div class="window">
<h2 class="title">Prefixes</h2>
<div class="content">
<p>Default (no prefix): <?php echo htmlentities($baseUri) ?></p>
<ul class="bullets-none separated-horizontal">
<?php
foreach ($nss as $uri => $prefix) {
	if ($uri != $baseUri) echo "<li><a href='$uri' title='$uri'>$prefix</a></li>\n";
}
?>
</ul>
</div>
<!-- window content --></div>
<!-- window --> <?php endif; ?>
<div class="window">
<h2 class="title"><?php echo $this->strings->query->result ?></h2>
<div class="content">
<div><input type="radio" class="radio" name="result_format"
	id="result_format_none" value="" checked="checked" /> <label
	for="result_format_none" class="checkboxradio"><?php echo $this->strings->query->table ?></label>
<br class="clearall">
<input type="radio" class="radio" name="result_format"
	id="result_format_xml" value="xml" /> <label for="result_format_xml"
	class="checkboxradio"><?php echo $this->strings->query->xml ?> <a
	href="http://www.w3.org/TR/rdf-sparql-XMLres/" title="Help!">[?]</a></label>
<br class="clearall">
</div>
<div><input type="checkbox" class="radio" name="resultsAsOwLinks"
	id="resultsAsOwLinksCheckBox" checked="checked" /> <label
	for="resultsAsOwLinksCheckBox" class="checkboxradio"><?php echo $this->strings->query->renderLinks ?></label>
</div>
</div>
<!-- window content --></div>
<!-- window --> <?php if (!$this->model instanceof RDFSModel): ?>
<div class="window">
<h2 class="title">Models</h2>
<div class="content">
<ul class="bullets-none separated-vertical">
<?php
$i = 0;
foreach (Zend_Registry::get('erfurt')->getStore()->listModels(true, true) as $m) {
	echo '<li>
							      <input type="checkbox" name="query_models[]" value="' . $m['modelURI'] . '" id="chk' . ++$i . '" />
							      <label class="checkboxradio" for="chk' . $i . '">' . $m['modelURI'] . '</label>
							</li>' . PHP_EOL;
}
?>
</ul>
</div>
<!-- window content --></div>
<!-- window --> <?php endif; ?></div>

</form>

</div>
<?php if ($this->results && !$this->errors): ?>
<script type="text/javascript">
//<![CDATA[

$jq(document).ready(function(){
		$jq('.section-mainwindows > .window').eq(0).toggleClass('is-processing');
		$jq('.section-mainwindows > .window').eq(0).toggleClass('is-minimized');
		var html = $jq('div[id=\'sparql_res\']').html();
		$jq('.section-mainwindows').append(html);
		$jq('div[id=\'sparql_res\']').empty();
		$jq('.section-mainwindows > .window').eq(0).toggleClass('is-processing');
		
	});
	
// ]]> 
</script>
<div id="sparql_res">
<!-- Rendering results (will be relocated by JavaScript later) -->
<?php echo $this->partial('micro/window.php',array(
	'content' => $this->results, 
	'tabs' => null,
	'title' => 'SPARQL Results'));
?>
</div>
<?php endif; ?>

<!-- From http://doapstore.org/sparql.php by Alexandre Passant -->
<script type="text/javascript">
//<![CDATA[

var editArea;

function init(){
   editArea = document.getElementById('sparqlArea');
}

function insertText(editField, insertText) {
// IE
   if (document.selection) {
      editField.focus();
      selected = document.selection.createRange();
      selected.text = insertText;
      return;
   } 
 // MOZ
   var length =  editField.value.length;
   var start = editField.selectionStart;
   var end = editField.selectionEnd;

   if ((start != 0) && (end != length)) { 
      var before = editField.value.substring(0, start);
      var after = editField.value.substring(end, length);
      editField.value = before + insertText + after;
   } else {
      editField.value += insertText;
   }
}

function insert(text){
   init();
   insertText(editArea, text + "\n");
}

function insertAtTop(editField, insertText) {
// IE - to do
   if (document.selection) {
insertText(editField, insertText);
}

 // MOZ
      editField.value = insertText+editField.value;
}

function insertAtStart(insertText) {
   init();
   insertAtTop(editArea, insertText + "\n");
}

// might not work with IE
function inset(editField, insetString) {
   var start = editField.selectionStart;
   var end = editField.selectionEnd;

    for(var c=start;c<end;c++){
   var length =  editField.value.length;
      var before = editField.value.substring(0, c);
      var after = editField.value.substring(c, length);
       if(editField.value.substring(c-1, c) == "\n") {
          editField.value = before + insetString + after;
          end = end+insetString.length;
       }
    }
}

function commentOut(editField) {
   inset(editField, "#");
}

function comment(){
   init();
   commentOut(editArea);
}

function indentArea(editField){
   inset(editField, "    ");
}

function indent(){
init();
   indentArea(editArea);
}

// might not work with IE
function makeOptional(editField) {

   var length =  editField.value.length;

   var start = editField.selectionStart;
   var end = editField.selectionEnd;

   var before = editField.value.substring(0, start);
   var after = editField.value.substring(end, length);

   var selection = editField.value.substring(start, end);

    editField.value = before + "\nOPTIONAL\n{\n" + selection + "\n}\n"+after;
}


// quick and dirty - wipes all # in selected region
function unCommentRegion(editField) {
   var length =  editField.value.length;
   var start = editField.selectionStart;
   var end = editField.selectionEnd;

    for(var c=start;c<end;c++){
      var before = editField.value.substring(0, c-1);
      var after = editField.value.substring(c, length);
       if(editField.value.substring(c-1, c) == "#") {
          editField.value = before + after;
       }
    }
}

function unComment(){
init();
   unCommentRegion(editArea);
}

function clearArea(editField){
   editField.value = "";
}

function clearAll(){
init();
   clearArea(editArea);
}

function optional(){
init();
   makeOptional(editArea);
}

// ]]> 
</script>