<?php

/**
  * OntoWiki resource view template
  *
  * @author Norman Heino
  * @version $Id: view.php 2762 2009-09-21 12:22:08Z triechert $
  */

?>
<?php $this->placeholder('tabs')->set($this->tabs) ?>
<?php $this->placeholder('title')->set($this->title) ?>
<?php $this->placeholder('menu')->set($this->menu) ?>
<?php $this->placeholder('statusTools')->set($this->statusTools) ?>

<?php /**
        * Capture inner windows for outer template
        */ ?>
<?php $this->placeholder('innerWindows')->captureStart('SET') ?>
	<?php echo $this->partial('micro/window.php', $this->ontoWikiBox('Editors')) ?>
	<?php echo $this->partial('micro/window.php', $this->ontoWikiBox('SimilarInstances')) ?>
	<?php echo $this->partial('micro/window.php', $this->ontoWikiBox('InstancesLinkingHere')) ?>
	<?php echo $this->partial('micro/window.php', $this->ontoWikiBox('UsageAsProperty')) ?>
<?php $this->placeholder('innerWindows')->captureEnd() ?>

<form method="post" action="<?php echo $this->actionUrl ?>">

<table cellspacing="0" class="separated-vertical edittable editable" id="table-<?php echo $this->tableId ?>" about="<?php echo $this->resourceLocal ?>">
<caption>Properties for <?php echo $this->resourceTitle ?></caption>

<?php foreach ($this->predicates as $predicate): ?>
<tr>
<td>
	<a rel="ow:internalLink" href="<?php echo $predicate['url'] ?>"><?php echo $predicate['title'] ?></a>
</td>
<td>
	<?php if (count($predicate['statements']) > 1): ?>
		<ul>
		<?php foreach ($predicate['statements'] as $statement): ?>
			<li><?php echo $this->partial('partials/object.php', array_merge($statement, array('type'           => $predicate['type'], 
			                                                                                   'editingAllowed' => $this->editingAllowed, 
			                                                                                   'themeBase'      => $this->themeBase, 
			                                                                                   'propUri'        => $predicate['uri']))) ?></li>
		<?php endforeach; ?>
		</ul>
	<?php else: ?>
		<?php echo $this->partial('partials/object.php', array_merge($predicate['statements'][0], array('type'           => $predicate['type'], 
		                                                                                                'editingAllowed' => $this->editingAllowed, 
						                                                                                'themeBase'      => $this->themeBase	, 
							                                                                            'propUri'        => $predicate['uri']))) ?>
	<?php endif; ?>

	<?php if (isset($predicate['moreStatements'])): ?>
		<?php echo $predicate['moreStatements'] ?>
	<?php endif; ?>
</td>
<td>
	<?php if ($this->editingAllowed): ?>
	<a class="inline-edit"><img class="clickicon inline-edit" src="<?php echo $this->themeBase ?>images/icon-edit.png" alt="edit" /></a>
	<?php endif; ?>
</td>
</tr>
<?php endforeach; ?>

</table>

<p>
<?php if ($this->editingAllowed): ?>
	<input type="hidden" name="olduri" value="<?php echo $this->oldUri ?>" />
	<a class="button inline-edit property-add" id="property-add-<?php echo $this->tableId ?>"><?php echo $this->strings->resource->addproperty ?></a>
	<button type="submit" name="submit" value="submit"><?php echo $this->strings->resource->submit ?></button>
	<!--<a class="button submit" id="form-submit-<?php echo $this->tableId ?>"><?php echo $this->strings->resource->submit ?></a>-->
<?php endif; ?>
</p>
</form>
